=== debian/changelog ===
freecad (0.20.1+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * autopkgtest: Disable test TestPathApp on s390x.

 -- Tobias Frost <tobi@debian.org>  Fri, 09 Sep 2022 17:01:54 +0200

freecad (0.20.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Tobias Frost <tobi@debian.org>  Fri, 26 Aug 2022 23:58:01 +0200

freecad (0.20+dfsg1-6) unstable; urgency=medium

  * Revert running freecad in the autopkgtest, this needs more work.

 -- Tobias Frost <tobi@debian.org>  Thu, 18 Aug 2022 21:30:34 +0200

freecad (0.20+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * Disable test femtest.app.test_solver_calculix.TestSolverCalculix, as
    this test is currently broken on some archs. Closes: #1017598.
  * Run freecad (gui executeable) test suite also in the autopkgtest,
    in the hope that missing libraries will be caught too (see #1013881).

 -- Tobias Frost <tobi@debian.org>  Thu, 18 Aug 2022 12:38:22 +0200

freecad (0.20+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on armel and armhf, GL_PROJECTION not declared in this scope
    with patch fix-1014875-arm-FTBFS.patch (Closes: #1014875)

 -- Tobias Frost <tobi@debian.org>  Tue, 09 Aug 2022 18:37:51 +0200

freecad (0.20+dfsg1-3) UNRELEASED; urgency=medium

  * d/u/metadata: Added SciCrunch RRID:SCR_022535

 -- Steffen Moeller <moeller@debian.org>  Tue, 05 Jul 2022 21:17:32 +0200

freecad (0.20+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * More verbose description.

 -- Steffen Moeller <moeller@debian.org>  Tue, 05 Jul 2022 02:16:00 +0200

freecad (0.20+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version. (Closes: #1007013)
  * Removed surface_extended_patch.patch - already found upstream
  * Removed remove_doc-files.patch - no longer applicable/needed
  * Removed fix_vtk9.patch - addressed upstream
  * Standards-Version: 4.6.1 (routine-update)
  * Extended runtime dependencies on python Qt modules as instructed
    upon execution of freecad.

 -- Steffen Moeller <moeller@debian.org>  Mon, 04 Jul 2022 15:29:38 +0200

freecad (0.19.4+dfsg1-1) unstable; urgency=medium

  * Team upload.

  * New upstream version - a bug-fix release
    Release notes: https://github.com/FreeCAD/FreeCAD/releases/tag/0.19.4
    - Fixes CVE-2021-45844 (Closes: #1005747)
    - Fixes CVE-2021-45845
  * Added link-time optimization

 -- Steffen Moeller <moeller@debian.org>  Fri, 04 Mar 2022 16:01:45 +0100

freecad (0.19.3+dfsg1-2) unstable; urgency=medium

  * Team upload.

  [ Håvard Flaget Aasen ]
  * Move files from /usr/share/freecad/share/* to /usr/share/*
  * Move appstream files from freecad-common to freecad, specifically
    /usr/share/applications/*, /usr/share/metainfo/* and /usr/share/mime/*.
    This will make sofware relying on appstream to install correct package.
    (Closes: #981175)
  * Don't install .xpm icon.
  * Prefer upstream version of desktop and sharedmimeinfo files.
  * Explicitly list folders to install in freecad-common.
  * Add patch to include previous set option in desktop file.
    Making freecad only run as single instance.

  [ Tobias Frost ]
  * Fix filename of SurfaceExtend icon (Closes: #992715)

 -- Steffen Moeller <moeller@debian.org>  Fri, 25 Feb 2022 14:04:59 +0100

freecad (0.19.3+dfsg1-1) unstable; urgency=medium

  * Team upload.

  [ Tobias Frost ]
  * Tighten dependencies on metapackage, so that the right version
    of all packages will be pulled on update. (Closes: #980474)

  [ Steffen Moeller ]
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * watch file standard 4 (routine-update)
  * patch/python3.8 adopted upstream
  * improved d/rules clean target for repeated builds

 -- Tobias Frost <tobi@debian.org>  Fri, 22 Oct 2021 12:45:02 +0200
